## clazy 1.8

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the Clazy project.
#
# To build the man page from POD, run 'make man' after CMake (assumes perl is available)
# To install the resulting man page, run 'make install'
# The man page is not available on Windows.
#

project(clazy)

cmake_minimum_required(VERSION 3.7)

if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
    cmake_policy(SET CMP0074 NEW)
endif()

include(FeatureSummary)
include(GenerateExportHeader)
include(GNUInstallDirs)

# Version setup
set(CLAZY_VERSION_MAJOR "1")
set(CLAZY_VERSION_MINOR "8")
set(CLAZY_VERSION_PATCH "0")
set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
if (NOT CLAZY_BUILD_WITH_CLANG)
  find_package(Clang 7.0 MODULE REQUIRED)

  if (CLANG_CLANG-CPP_LIB AND NOT APPLE)
    set(default_use_clang_cpp ON)
  else()
    set(default_use_clang_cpp OFF)
  endif()
  option(CLAZY_LINK_CLANG_DYLIB "Link clazy to dynamic Clang C++ library clang-cpp." ${default_use_clang_cpp})
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

add_definitions(-D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS)
add_definitions(-D_GNU_SOURCE -DHAVE_CLANG_CONFIG_H)

option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)
option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)

if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
    add_definitions(-DCLAZY_DISABLE_AST_MATCHERS)
endif()

if(NOT CLAZY_BUILD_WITH_CLANG AND MSVC AND NOT CLANG_LIBRARY_IMPORT)
  message(FATAL_ERROR "\nOn MSVC you need to pass -DCLANG_LIBRARY_IMPORT=C:/path/to/llvm-build/lib/clang.lib to cmake when building Clazy.\nAlso make sure you've built LLVM with -DLLVM_EXPORT_SYMBOLS_FOR_PLUGINS=ON")
endif()

if(MSVC)
  # disable trigger-happy warnings from Clang/LLVM headers
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267 /wd4244 /wd4291 /wd4800 /wd4141 /wd4146 /wd4251")
elseif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
endif()

set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
if(WIN32)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
endif()

# Look for std::regex support
message("Looking for std::regex support...")
try_run(REGEX_RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)

if(NOT REGEX_RUN_RESULT EQUAL 0)
  message("Using boost::regex instead of std::regex")
  set(CLAZY_USES_BOOST_REGEX TRUE)
  add_definitions(-DCLAZY_USES_BOOST_REGEX)
  find_package(Boost REQUIRED COMPONENTS regex)
  include_directories(${Boost_INCLUDE_DIRS})
endif()

# Compiler might support c++17 but not have std::filesystem in the standard library
message("Looking for std::filesystem support...")
try_run(FILESYSTEM_RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)

if (FILESYSTEM_RUN_RESULT EQUAL 0 AND COMPILE_RESULT)
    set(CMAKE_CXX_STANDARD 17)
    add_definitions(-DHAS_STD_FILESYSTEM)
endif()

include(ClazySources.cmake)

include_directories(${CMAKE_BINARY_DIR})
include_directories(${CLANG_INCLUDE_DIRS} ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_LIST_DIR}/src)
link_directories("${LLVM_INSTALL_PREFIX}/lib" ${LLVM_LIBRARY_DIRS})

if (${LLVM_VERSION} VERSION_GREATER_EQUAL "9.0.0")
    set(clang_tooling_refactoring_lib clangToolingRefactoring)
else()
    set(clang_tooling_refactoring_lib clangToolingRefactor)
endif()

macro(link_to_llvm name is_standalone)
  if (CLAZY_LINK_CLANG_DYLIB)
    target_link_libraries(${name} clang-cpp)
  else()
    foreach(clang_lib ${CLANG_LIBS})
      if(MSVC)
        get_filename_component(LIB_FILENAME ${clang_lib} NAME)
        if(LIB_FILENAME STREQUAL "clangFrontend.lib")
          # On MSVC we don't link against clangFrontend.lib, instead we link against clang.exe (via clang.lib)
          # Otherwise the clazy plugin would have it's own plugin registry and clang wouldn't see it.
          # This way clazy registers with clang.
          continue()
        endif()
      endif()

      target_link_libraries(${name} ${clang_lib})
    endforeach()
    target_link_libraries(${name} clangTooling)
    target_link_libraries(${name} clangToolingCore)
    target_link_libraries(${name} ${clang_tooling_refactoring_lib})
  endif()

  foreach(llvm_lib ${LLVM_LIBS})
    if(NOT ${is_standalone} AND NOT APPLE AND NOT MINGW AND NOT MSVC)
        ## Don't link against LLVMSupport, causes: CommandLine Error: Option 'view-background' registered more than once!
        if (NOT llvm_lib MATCHES ".*LLVMSupport.*")
            target_link_libraries(${name} ${llvm_lib})
        endif()
    else()
        target_link_libraries(${name} ${llvm_lib})
    endif()
  endforeach()

  foreach(user_lib ${USER_LIBS})
    target_link_libraries(${name} ${user_lib})
  endforeach()

  foreach(llvm_system_lib ${LLVM_SYSTEM_LIBS})
    target_link_libraries(${name} ${llvm_system_lib})
  endforeach()

  if(WIN32)
    target_link_libraries(${name} version.lib)
  endif()
  if (CLAZY_USES_BOOST_REGEX)
    target_link_libraries(${name} ${Boost_LIBRARIES})
  endif()
endmacro()

macro(add_clang_plugin name)
  set(srcs ${ARGN})

  add_library(${name} SHARED ${srcs})

  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.16.0")
      # 30% speedup
      target_precompile_headers(${name} PRIVATE src/checkbase.h)
  endif()

  if(SYMBOL_FILE)
    set_target_properties(${name} PROPERTIES LINK_FlAGS "-exported_symbols_list ${SYMBOL_FILE}")
  endif()

  if (LINK_CLAZY_TO_LLVM)
    link_to_llvm(${name} FALSE)
  else()
    if (APPIMAGE_HACK)
        # Hack to build on old CentOS 6.8
        target_link_libraries(${name} clangTooling)
        target_link_libraries(${name} clangToolingCore)
        target_link_libraries(${name} ${clang_tooling_refactoring_lib})
    endif()
  endif()

  if(MSVC)
    target_link_libraries(${name} ${CLANG_LIBRARY_IMPORT}) # Link against clang.exe to share the plugin registry
  endif()

endmacro()

set(SYMBOL_FILE Lazy.exports)

if (NOT CLAZY_BUILD_WITH_CLANG)
  set(CLAZY_MINI_AST_DUMPER_SRCS src/MiniAstDumper.cpp)
  add_clang_plugin(ClazyPlugin ${CLAZY_PLUGIN_SRCS} ${CLAZY_MINI_AST_DUMPER_SRCS})
  set_target_properties(ClazyPlugin PROPERTIES
    LINKER_LANGUAGE CXX
    PREFIX ""
  )

  install(TARGETS ClazyPlugin
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

  if(NOT WIN32)
    if(APPLE)
      find_program(READLINK_CMD greadlink)
    else()
      find_program(READLINK_CMD readlink)
    endif()
    if(NOT READLINK_CMD)
      message(FATAL_ERROR "Could not find a proper readlink.  On Mac OSX you should install coreutils using homebrew in order to use the GNU readlink")
    endif()
    file(RELATIVE_PATH BIN_RELATIVE_LIBDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
    file(RELATIVE_PATH BIN_RELATIVE_SHAREDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
    configure_file(${CMAKE_CURRENT_LIST_DIR}/clazy.cmake ${CMAKE_BINARY_DIR}/clazy @ONLY)
    install(PROGRAMS ${CMAKE_BINARY_DIR}/clazy DESTINATION bin)
  else()
    install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/clazy.bat DESTINATION ${CMAKE_INSTALL_BINDIR})
    if(MSVC)
      install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/clazy-cl.bat DESTINATION ${CMAKE_INSTALL_BINDIR})
    endif()
  endif()

  # Install the explanation README's
  include(${CMAKE_CURRENT_LIST_DIR}/readmes.cmake)

  install(FILES ${README_LEVEL0_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/level0)
  install(FILES ${README_LEVEL1_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/level1)
  install(FILES ${README_LEVEL2_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/level2)
  install(FILES ${README_manuallevel_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/manuallevel)

  # Install more doc files
  install(FILES README.md COPYING-LGPL2.txt checks.json DESTINATION ${CMAKE_INSTALL_DOCDIR})

  # Build docs
  add_subdirectory(docs)

  # rpath
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  endif("${isSystemDir}" STREQUAL "-1")

  # Build clazy-standalone
  add_executable(clazy-standalone ${CLAZY_STANDALONE_SRCS})

  if(MSVC)
    # On MSVC clang-standalone crashes with a meaningless backtrace if linked to ClazyPlugin.dll
    target_link_libraries(clazy-standalone clangFrontend)
  else()
    target_link_libraries(clazy-standalone ClazyPlugin)
  endif()

  link_to_llvm(clazy-standalone TRUE)

  install(TARGETS clazy-standalone DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)

  set(CPACK_PACKAGE_VERSION_MAJOR ${CLAZY_VERSION_MAJOR})
  set(CPACK_PACKAGE_VERSION_MINOR ${CLAZY_VERSION_MINOR})
  set(CPACK_PACKAGE_VERSION_PATCH ${CLAZY_VERSION_PATCH})
  include(CPack)
else()
  set(LLVM_LINK_COMPONENTS
    Support
    )
  add_clang_library(clazyPlugin
    ${CLAZY_PLUGIN_SRCS}

    LINK_LIBS
    clangToolingCore
    clangToolingInclusions
    ${clang_tooling_refactoring_lib}
    clangFrontend
    clangDriver
    clangCodeGen
    clangSema
    clangAnalysis
    clangRewriteFrontend
    clangRewrite
    clangAST
    clangASTMatchers
    clangParse
    clangLex
    clangBasic
    clangARCMigrate
    clangEdit
    clangFrontendTool
    clangRewrite
    clangSerialization
    clangTooling
    clangStaticAnalyzerCheckers
    clangStaticAnalyzerCore
    clangStaticAnalyzerFrontend
    )
  add_executable(clazy-standalone ${CLAZY_STANDALONE_SRCS})

  target_link_libraries(clazy-standalone clazyPlugin)

  install(TARGETS clazy-standalone DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
endif()

function(to_raw_string_literal input_string output_string)
    if (MSVC)
        # Work around "C2026: string too big, trailing characters truncated"
        #   https://docs.microsoft.com/en-us/cpp/error-messages/compiler-errors-1/compiler-error-c2026?view=vs-2019
        # The limit is 16380 single-byte characters, so split up the string as
        # suggested on the site.
        set(str ${input_string})
        set(chunk_size 1000)
        set(result "\n")
        string(LENGTH ${str} str_size)
        while (${str_size} GREATER ${chunk_size})
            string(SUBSTRING ${str} 0 ${chunk_size} chunk)
            string(SUBSTRING ${str} ${chunk_size} -1 str)
            set(chunk "R\"meta(${chunk})meta\"\n")
            string(APPEND result ${chunk})
            string(LENGTH ${str} str_size)
        endwhile()
        if (str_size GREATER 0)

=== debian/changelog ===
clazy (1.8-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_inefficient-qlist-Disable-flaky-test-on-arm-32bit.patch: drop,
      backported from upstream
    - upstream_updated-for-compatibility-with-LLVM-10.patch: drop, backported
      from upstream
    - upstream_deleted-redundant-qualifier.patch: drop, backported from
      upstream
    - upstream_updated-for-compatibility-with-LLVM-10-clazy-standal.patch:
      drop, backported from upstream
    - debian-tests-link-atomic.diff: refresh
    - select-clangpp.diff: refresh
  * Bump Standards-Version to 4.5.1, no changes required.
  * Update the build dependencies according to the upstream build system:
    - bump clang & LLVM to 7.0
  * Backport upstream commit 04d38721ba951a9cafd276d584880d3f72c7794a, and
    commit c1dc65494574227646e1dd36675a5bd906660647 to fix two test cases;
    patches upstream_qt6-deprecated-api-fixes-Remove-unrelated-warnings-f.patch
    and upstream_qt6-qlatin1stringchar-to-u-Only-run-tests-with-clang.patch.

 -- Pino Toscano <pino@debian.org>  Mon, 23 Nov 2020 19:34:07 +0100

clazy (1.7-5) unstable; urgency=medium

  * Upload to unstable.
  * Backport upstream commits 30d6a2b64f5a05722fdc5d8e3754dbf13425cd62,
    86796d87c9118cec4795d77349e3e607df35c3b8, and
    25aa102cc49def9573ffbed88155589cd60a2e8f to fix compatibility with
    LLVM >= 10; patches upstream_updated-for-compatibility-with-LLVM-10.patch,
    upstream_deleted-redundant-qualifier.patch, and
    upstream_updated-for-compatibility-with-LLVM-10-clazy-standal.patch.

 -- Pino Toscano <pino@debian.org>  Mon, 02 Nov 2020 10:51:51 +0100

clazy (1.7-4) experimental; urgency=medium

  * Add a new package clazy-tests, mostly for autopkgtest purposes:
    - use --destdir=debian/clazy to install everything directly in clazy
    - make clazy-tests depend on the exact clazy version
    - make clazy-tests depend on the package (clang-tools-N) that provides
      the default version of clang-apply-replacements
  * Ship a shell file /usr/share/clazy/debian-$(DPKG_ARCHITECTURE).sh in
    clazy-tests with the paths of clang and clang-apply-replacements.
  * Adapt the run-tests autopkgtest to clazy-tests: (Closes: #952464, #971589)
    - replace the clang, and clang-tools dependencies with clazy-tests
    - source the shell configuration file provided by clazy-tests
    - export the right environment variables for clang, and
      clang-apply-replacements, so the upstream test script can use them
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
  * Minimize the upstream GPG signing key.
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).
  * Update references to the upstream Git repository.

 -- Pino Toscano <pino@debian.org>  Sun, 01 Nov 2020 19:06:17 +0100

clazy (1.7-3) unstable; urgency=medium

  * Backport upstream commit dbde38f1a67c2968c951629a5f5629c9847078bd to skip
    the inefficient-qlist test on any 32bit architecture; patch
    upstream_inefficient-qlist-Disable-flaky-test-on-arm-32bit.patch
    (Closes: #964137)
    - stop manually excluding it in rules

 -- Pino Toscano <pino@debian.org>  Sat, 04 Jul 2020 11:41:50 +0200

=== debian/control ===
Source: clazy
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Scarlett Clark <sgclark@kde.org>,
 Pino Toscano <pino@debian.org>
Build-Depends: chrpath,
               clang (>= 1:7.0~),
               clang-tools (>= 1:7.0~),
               cmake (>= 3.7~),
               debhelper-compat (= 13),
               libclang-dev (>= 1:7.0~),
               llvm-dev (>= 1:7.0~),
               python3:any <!nocheck>,
               qtbase5-dev <!nocheck>,
               qtdeclarative5-dev <!nocheck>,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://www.kdab.com/clazy-video/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy

Package: clazy
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${clazy:clang}
Description: Clang plugin for additional warnings
 Clazy is a Clang plugin which extends the compiler with over
 50 warnings related to Qt best practices ranging from unneeded
 memory allocations to API misuse. It’s an opensource project
 spawned by KDAB’s R&D efforts for better C++ tooling.

Package: clazy-tests
Architecture: any
Depends: ${misc:Depends}, clazy (= ${binary:Version}),
         ${clazy:clang-tools},
Description: test files for Clazy
 This package contains all the test files needed for running the autopkgtest
 of Clazy. This is hardly useful to install in any other context than this.

## clazy 1.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "8")
+set(CLAZY_VERSION_MINOR "9")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
@@ -46,6 +46,7 @@
 option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)
 option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
 option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
+option(CLAZY_MAN_PAGE "Builds the man page." ON)
 
 if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
     message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
@@ -231,7 +232,9 @@
   install(FILES README.md COPYING-LGPL2.txt checks.json DESTINATION ${CMAKE_INSTALL_DOCDIR})
 
   # Build docs
-  add_subdirectory(docs)
+  if (CLAZY_MAN_PAGE)
+    add_subdirectory(docs)
+  endif()
 
   # rpath
   set(CMAKE_SKIP_BUILD_RPATH FALSE)
@@ -316,6 +319,3 @@
             string(SUBSTRING ${str} ${chunk_size} -1 str)
             set(chunk "R\"meta(${chunk})meta\"\n")
             string(APPEND result ${chunk})
-            string(LENGTH ${str} str_size)
-        endwhile()
-        if (str_size GREATER 0)

=== debian/changelog ===
clazy (1.9-3) unstable; urgency=medium

  * Exclude the qt6-header-fixes check on armel & armhf also when running the
    run-tests autopkgtest.

 -- Pino Toscano <pino@debian.org>  Tue, 12 Jan 2021 16:17:14 +0100

clazy (1.9-2) unstable; urgency=medium

  * Exclude the qt6-header-fixes check on armel & armhf, as on these
    architectures there are the OpenGL ES headers that interfere with the test.

 -- Pino Toscano <pino@debian.org>  Mon, 11 Jan 2021 09:32:30 +0100

clazy (1.9-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_qt6-deprecated-api-fixes-Remove-unrelated-warnings-f.patch:
      drop, backported from upstream
    - upstream_qt6-qlatin1stringchar-to-u-Only-run-tests-with-clang.patch:
      drop, backported from upstream

 -- Pino Toscano <pino@debian.org>  Mon, 11 Jan 2021 00:54:37 +0100

clazy (1.8-2) unstable; urgency=medium

  * Add the libclang-cpp-dev build dependency to link against the shared
    libclang-cpp; hopefully this avoids problems when the LLVM version changes
    (due to the static linking).

 -- Pino Toscano <pino@debian.org>  Mon, 21 Dec 2020 12:17:32 +0100

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
                clang-tools (>= 1:7.0~),
                cmake (>= 3.7~),
                debhelper-compat (= 13),
+               libclang-cpp-dev (>= 1:7.0~),
                libclang-dev (>= 1:7.0~),
                llvm-dev (>= 1:7.0~),
                python3:any <!nocheck>,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# LLVM 6.0 headers produce lots of class-memaccess warnings
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-class-memaccess

archs_that_need_atomic = armel
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

# on armel & armhf there are OpenGL ES headers
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), armel armhf))
RUN_TESTS_ARGS += --exclude qt6-header-fixes
endif

# keep the "++" at the end, to make sure the tool used is the C++ frontend
CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++))++
CLANG_APPLY_REPLACEMENTS=$(shell realpath $$(which clang-apply-replacements))

DPKG_ARCHITECTURE = $(shell dpkg --print-architecture)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)"

override_dh_auto_install:
	dh_auto_install --destdir=debian/clazy
	# drop RPATH pointing to the private libdir of LLVM libraries,
	# i.e. /usr/lib/llvm-$VERSION/lib
	chrpath -d $(CURDIR)/debian/clazy/usr/bin/clazy-standalone $(CURDIR)/debian/clazy/usr/lib/*/*.so
	# drop extra license file
	rm $(CURDIR)/debian/clazy/usr/share/doc/clazy/COPYING-LGPL2.txt
	# create a local shell environment file with the various paths
	:> $(CURDIR)/debian/debian.sh
	echo 'export CLANG="$(CLANGPP)"' >> $(CURDIR)/debian/debian.sh
	echo 'export CLANG_APPLY_REPLACEMENTS="$(CLANG_APPLY_REPLACEMENTS)"' >> $(CURDIR)/debian/debian.sh
	mkdir -p $(CURDIR)/debian/clazy-tests/usr/share/clazy
	mv $(CURDIR)/debian/debian.sh $(CURDIR)/debian/clazy-tests/usr/share/clazy/debian-$(DPKG_ARCHITECTURE).sh

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	chmod +x $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/clazy
	cd tests && env PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib DEB_HOST_ARCH=$(DEB_HOST_ARCH) CCACHE_DISABLE=1 ./run_tests.py --verbose $(RUN_TESTS_ARGS)
endif

override_dh_compress:
	# do not compress documentation markdown & JSON files
	dh_compress -X.md -X.json

override_dh_gencontrol:
	dh_gencontrol -- \
	  -V'clazy:clang=$(shell dpkg -S "$(CLANGPP)" | cut -d: -f1)' \
	  -V'clazy:clang-tools=$(shell dpkg -S "$(CLANG_APPLY_REPLACEMENTS)" | cut -d: -f1)'

## clazy 1.10

=== debian/changelog ===
clazy (1.10-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - debian-tests-link-atomic.diff: refresh
    - select-clangpp.diff: refresh
  * Update the build dependencies according to the upstream build system:
    - bump clang & LLVM to 8.0
  * Pass -DREADLINK_CMD:FILEPATH=/usr/bin/readlink to cmake to force the path
    of readlink(1), so it does not change depending on usrmerge.

 -- Pino Toscano <pino@debian.org>  Tue, 17 Aug 2021 06:02:34 +0200

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Scarlett Clark <sgclark@kde.org>,
  Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang (>= 1:7.0~),
-               clang-tools (>= 1:7.0~),
+               clang (>= 1:8.0~),
+               clang-tools (>= 1:8.0~),
                cmake (>= 3.7~),
                debhelper-compat (= 13),
-               libclang-cpp-dev (>= 1:7.0~),
-               libclang-dev (>= 1:7.0~),
-               llvm-dev (>= 1:7.0~),
+               libclang-cpp-dev (>= 1:8.0~),
+               libclang-dev (>= 1:8.0~),
+               llvm-dev (>= 1:8.0~),
                python3:any <!nocheck>,
                qtbase5-dev <!nocheck>,
                qtdeclarative5-dev <!nocheck>,

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)"
+	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DREADLINK_CMD:FILEPATH=/usr/bin/readlink
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/clazy

## clazy 1.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,14 +19,14 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "9")
+set(CLAZY_VERSION_MINOR "11")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
 if (NOT CLAZY_BUILD_WITH_CLANG)
-  find_package(Clang 7.0 MODULE REQUIRED)
+  find_package(Clang 8.0 MODULE REQUIRED)
 
   if (CLANG_CLANG-CPP_LIB AND NOT APPLE)
     set(default_use_clang_cpp ON)
@@ -47,6 +47,14 @@
 option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
 option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
 option(CLAZY_MAN_PAGE "Builds the man page." ON)
+option(CLAZY_ENABLE_SANITIZERS "Builds clazy with ASAN/UBSAN. For clazy's own development only." OFF)
+
+if (CLAZY_ENABLE_SANITIZERS)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
+    if (NOT MSVC)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined")
+    endif()
+endif()
 
 if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
     message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
@@ -61,7 +69,7 @@
   # disable trigger-happy warnings from Clang/LLVM headers
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267 /wd4244 /wd4291 /wd4800 /wd4141 /wd4146 /wd4251")
 elseif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
 endif()
 
 set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
@@ -83,12 +91,14 @@
   include_directories(${Boost_INCLUDE_DIRS})
 endif()
 
+set(CMAKE_CXX_STANDARD 17)
+set(CXX_STANDARD_REQUIRED ON)
+
 # Compiler might support c++17 but not have std::filesystem in the standard library
 message("Looking for std::filesystem support...")
 try_run(FILESYSTEM_RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)
 
 if (FILESYSTEM_RUN_RESULT EQUAL 0 AND COMPILE_RESULT)
-    set(CMAKE_CXX_STANDARD 17)
     add_definitions(-DHAS_STD_FILESYSTEM)
 endif()
 
@@ -313,9 +323,3 @@
         set(str ${input_string})
         set(chunk_size 1000)
         set(result "\n")
-        string(LENGTH ${str} str_size)
-        while (${str_size} GREATER ${chunk_size})
-            string(SUBSTRING ${str} 0 ${chunk_size} chunk)
-            string(SUBSTRING ${str} ${chunk_size} -1 str)
-            set(chunk "R\"meta(${chunk})meta\"\n")
-            string(APPEND result ${chunk})

=== debian/changelog ===
clazy (1.11-4ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:40:01 +1100

clazy (1.11-4ubuntu1) noble; urgency=medium

  * Explicitly build with LLVM 15, as done before.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 21:59:53 +0100

clazy (1.11-4build1) noble; urgency=medium

  * No-change rebuild against libllvm.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 20:23:57 +0100

clazy (1.11-4) unstable; urgency=medium

  * Team upload.
  * Remove the second reserve-candidates test.

 -- Simon Quigley <tsimonq2@debian.org>  Wed, 18 Jan 2023 14:40:12 -0600

clazy (1.11-3) unstable; urgency=medium

  * Export $DEB_HOST_ARCH in the 'run-tests' autopkgtest: this way, the local
    changes to run_tests.py can enable the linking to atomic on armel, where
    it is needed; this fixed the autopkgtest on that architecture.

 -- Pino Toscano <pino@debian.org>  Fri, 18 Nov 2022 12:19:43 +0100

clazy (1.11-2) unstable; urgency=medium

  * Backport upstream commit f5c95d3cb453ca16980db268556f23ca3cd38122 to fix
    the detection of the clang version when running the tests; patch
    upstream_tests-fix-clang-version-regexp.patch.
  * Update standards version to 4.6.1, no changes needed.
  * Limit the parallel jobs for the tests ran during the build using
    $DEB_BUILD_OPTIONS:
    - backport upstream commit ab8993c9e10e09cb24210f76bb5e67f01bb37a9e to add
      -j/--jobs to the run_tests.py script; patch
      upstream_tests-add-j-jobs-option-for-run_tests.py.patch
    - pass --jobs to run_tests.py with the number of parallel jobs specified
      in $DEB_BUILD_OPTIONS, defaulting to 1
  * Set the number of parallel jobs in the 'run-tests' autopkgtest to 1 for
    now.
  * Remove inactive Uploaders.
  * Backport upstream commit 20fca52da739ebefa47e35f6b338bb99a0da3cfe to support
    LLVM/Clang 15.0.0; patch upstream_Build-fixes-for-LLVM-Clang-15.0.0.patch.

 -- Pino Toscano <pino@debian.org>  Thu, 17 Nov 2022 20:21:31 +0100

clazy (1.11-1) unstable; urgency=medium

  * New upstream release.
  * Drop -std=gnu++14 from the CXXFLAGS, as it should build fine now.
  * Update the patches:
    - select-clangpp.diff: refresh

 -- Pino Toscano <pino@debian.org>  Sat, 22 Jan 2022 11:11:20 +0100

clazy (1.10-2) unstable; urgency=medium

  * Fix -DREADLINK_CMD:FILEPATH to be /bin/readlink, like the actual file path
    provided by coreutils.
  * Bump Standards-Version to 4.6.0, no changes required.
  * Add -std=gnu++14 to the CXXFLAGS to build with C++14, as it seems it fails
    to build with C++17 (default of GCC 11).

 -- Pino Toscano <pino@debian.org>  Mon, 22 Nov 2021 22:38:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,21 @@
 Source: clazy
 Section: devel
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Scarlett Clark <sgclark@kde.org>,
- Pino Toscano <pino@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang (>= 1:8.0~),
-               clang-tools (>= 1:8.0~),
+               clang-15 (>= 1:8.0~),
+               clang-tools-15 (>= 1:8.0~),
                cmake (>= 3.7~),
                debhelper-compat (= 13),
-               libclang-cpp-dev (>= 1:8.0~),
-               libclang-dev (>= 1:8.0~),
-               llvm-dev (>= 1:8.0~),
+               libclang-cpp15-dev (>= 1:8.0~),
+               libclang-15-dev (>= 1:8.0~),
+               llvm-15-dev (>= 1:8.0~),
                python3:any <!nocheck>,
                qtbase5-dev <!nocheck>,
                qtdeclarative5-dev <!nocheck>,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/buildopts.mk
+
+export PATH := /usr/lib/llvm-15/bin:$(PATH)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -27,7 +30,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DREADLINK_CMD:FILEPATH=/usr/bin/readlink
+	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DREADLINK_CMD:FILEPATH=/bin/readlink
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/clazy
@@ -46,7 +49,7 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	chmod +x $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/clazy
-	cd tests && env PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib DEB_HOST_ARCH=$(DEB_HOST_ARCH) CCACHE_DISABLE=1 ./run_tests.py --verbose $(RUN_TESTS_ARGS)
+	cd tests && env PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib DEB_HOST_ARCH=$(DEB_HOST_ARCH) CCACHE_DISABLE=1 ./run_tests.py --verbose --jobs $(or $(DEB_BUILD_OPTION_PARALLEL),$(DEB_BUILD_OPTION_PARALLEL),1) $(RUN_TESTS_ARGS)
 endif
 
 override_dh_compress:

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
https://download.kde.org/stable/@PACKAGE@/([\d\.]*)/src/@PACKAGE@-([^-]*).tar.xz

## clazy 1.12

=== debian/changelog ===
clazy (1.12-1) unstable; urgency=medium

  * New upstream release:
    - supports up to LLVM 18 (Closes: #1051858)
  * Update standards version to 4.7.0, no changes needed.
  * Clean the generated files of the test suite run. (Closes: #1044015)
  * Update the patches:
    - upstream_tests-fix-clang-version-regexp.patch: drop, backported from
      upstream
    - upstream_tests-add-j-jobs-option-for-run_tests.py.patch: drop, backported
      from upstream
    - upstream_Build-fixes-for-LLVM-Clang-15.0.0.patch: drop, backported from
      upstream
    - debian-tests-link-atomic.diff: refresh/update
    - select-clangpp.diff: refresh
    - disable-reserve-candidates-flaky.patch: drop, no more needed
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.8
    - bump clang & LLVM to 11.0
  * Add more dependencies as test build dependency, and for the 'run-tests'
    autopkgtest, needed by the new upstream release:
    - libqt5networkauth5-dev, libqt5svg5-dev, qtmultimedia5-dev
    - qt6-base-dev, qt6-declarative-dev, qt6-multimedia-dev,
      qt6-networkauth-dev, qt6-scxml-dev, qt6-svg-dev
  * Update the license file to drop from the installed documentation.
  * The rebuild will make it usable with GCC 13. (Closes: #1043011)

 -- Pino Toscano <pino@debian.org>  Thu, 04 Jul 2024 20:06:47 +0200

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,29 @@
 Source: clazy
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang-15 (>= 1:8.0~),
-               clang-tools-15 (>= 1:8.0~),
-               cmake (>= 3.7~),
+               clang (>= 1:11.0~),
+               clang-tools (>= 1:11.0~),
+               cmake (>= 3.8~),
                debhelper-compat (= 13),
-               libclang-cpp15-dev (>= 1:8.0~),
-               libclang-15-dev (>= 1:8.0~),
-               llvm-15-dev (>= 1:8.0~),
+               libclang-cpp-dev (>= 1:11.0~),
+               libclang-dev (>= 1:11.0~),
+               llvm-dev (>= 1:11.0~),
                python3:any <!nocheck>,
+               libqt5networkauth5-dev <!nocheck>,
                qtbase5-dev <!nocheck>,
+               libqt5svg5-dev <!nocheck>,
                qtdeclarative5-dev <!nocheck>,
-Standards-Version: 4.6.1
+               qtmultimedia5-dev <!nocheck>,
+               qt6-base-dev <!nocheck>,
+               qt6-declarative-dev <!nocheck>,
+               qt6-multimedia-dev <!nocheck>,
+               qt6-networkauth-dev <!nocheck>,
+               qt6-scxml-dev <!nocheck>,
+               qt6-svg-dev <!nocheck>,
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git

=== debian/rules ===
--- 
+++ 
@@ -2,8 +2,6 @@
 
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildopts.mk
-
-export PATH := /usr/lib/llvm-15/bin:$(PATH)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -29,6 +27,10 @@
 %:
 	dh $@
 
+execute_after_dh_auto_clean:
+	# cleanup the artifacts of the tests
+	find tests/ \( -name '*.o' -o -name '*.out' -o -name '*.result' -o -name '*.gch' \) -delete
+
 override_dh_auto_configure:
 	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DREADLINK_CMD:FILEPATH=/bin/readlink
 
@@ -38,7 +40,7 @@
 	# i.e. /usr/lib/llvm-$VERSION/lib
 	chrpath -d $(CURDIR)/debian/clazy/usr/bin/clazy-standalone $(CURDIR)/debian/clazy/usr/lib/*/*.so
 	# drop extra license file
-	rm $(CURDIR)/debian/clazy/usr/share/doc/clazy/COPYING-LGPL2.txt
+	rm $(CURDIR)/debian/clazy/usr/share/doc/clazy/LGPL-2.0-or-later.txt
 	# create a local shell environment file with the various paths
 	:> $(CURDIR)/debian/debian.sh
 	echo 'export CLANG="$(CLANGPP)"' >> $(CURDIR)/debian/debian.sh

## clazy 1.12+git20241123

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,9 +5,9 @@
 # The man page is not available on Windows.
 #
 
+cmake_minimum_required(VERSION 3.8)
+
 project(clazy)
-
-cmake_minimum_required(VERSION 3.7)
 
 if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
     cmake_policy(SET CMP0074 NEW)
@@ -19,14 +19,14 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "11")
+set(CLAZY_VERSION_MINOR "13")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
 if (NOT CLAZY_BUILD_WITH_CLANG)
-  find_package(Clang 8.0 MODULE REQUIRED)
+  find_package(Clang 14.0 MODULE REQUIRED)
 
   if (CLANG_CLANG-CPP_LIB AND NOT APPLE)
     set(default_use_clang_cpp ON)
@@ -42,8 +42,8 @@
 
 add_definitions(-D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS)
 add_definitions(-D_GNU_SOURCE -DHAVE_CLANG_CONFIG_H)
-
-option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)
+add_definitions(-DCLAZY_VERSION="${CLAZY_PRINT_VERSION}")
+
 option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
 option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
 option(CLAZY_MAN_PAGE "Builds the man page." ON)
@@ -54,11 +54,6 @@
     if (NOT MSVC)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined")
     endif()
-endif()
-
-if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
-    message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
-    add_definitions(-DCLAZY_DISABLE_AST_MATCHERS)
 endif()
 
 if(NOT CLAZY_BUILD_WITH_CLANG AND MSVC AND NOT CLANG_LIBRARY_IMPORT)
@@ -79,27 +74,26 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
 endif()
 
-# Look for std::regex support
-message("Looking for std::regex support...")
-try_run(REGEX_RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)
-
-if(NOT REGEX_RUN_RESULT EQUAL 0)
-  message("Using boost::regex instead of std::regex")
-  set(CLAZY_USES_BOOST_REGEX TRUE)
-  add_definitions(-DCLAZY_USES_BOOST_REGEX)
-  find_package(Boost REQUIRED COMPONENTS regex)
-  include_directories(${Boost_INCLUDE_DIRS})
-endif()
-
 set(CMAKE_CXX_STANDARD 17)
 set(CXX_STANDARD_REQUIRED ON)
 
+# Look for std::regex support
+if(NOT DEFINED REGEX_RUN_RESULT)
+  message("Looking for std::regex support...")
+  try_compile(REGEX_RUN_RESULT ${CMAKE_CURRENT_BINARY_DIR} SOURCES ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)
+endif()
+
+if(NOT DEFINED REGEX_RUN_RESULT)
+  message(FATAL_ERROR "std::regex support is mandatory")
+endif()
+
 # Compiler might support c++17 but not have std::filesystem in the standard library
-message("Looking for std::filesystem support...")
-try_run(FILESYSTEM_RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)
-
-if (FILESYSTEM_RUN_RESULT EQUAL 0 AND COMPILE_RESULT)
-    add_definitions(-DHAS_STD_FILESYSTEM)
+if (NOT FILESYSTEM_RUN_RESULT)
+  try_compile(FILESYSTEM_RUN_RESULT ${CMAKE_CURRENT_BINARY_DIR} SOURCES ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_filesystem_test.cpp OUTPUT_VARIABLE foo CXX_STANDARD 17 CXX_STANDARD_REQUIRED true)
+endif()
+
+if (NOT FILESYSTEM_RUN_RESULT)
+  message(FATAL_ERROR "std::filesystem support is mandatory")
 endif()
 
 include(ClazySources.cmake)
@@ -108,10 +102,12 @@
 include_directories(${CLANG_INCLUDE_DIRS} ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_LIST_DIR}/src)
 link_directories("${LLVM_INSTALL_PREFIX}/lib" ${LLVM_LIBRARY_DIRS})
 
-if (${LLVM_VERSION} VERSION_GREATER_EQUAL "9.0.0")
-    set(clang_tooling_refactoring_lib clangToolingRefactoring)
-else()
-    set(clang_tooling_refactoring_lib clangToolingRefactor)
+set(clang_tooling_refactoring_lib clangToolingRefactoring)
+
+if (${LLVM_VERSION} VERSION_GREATER_EQUAL "19.0.0")
+  set(clang_support_lib clangSupport)
+elseif (${LLVM_VERSION} VERSION_GREATER_EQUAL "15.0.0")
+  set(clang_support_lib clangSupport)
 endif()
 
 macro(link_to_llvm name is_standalone)
@@ -131,6 +127,7 @@
 
       target_link_libraries(${name} ${clang_lib})
     endforeach()
+    target_link_libraries(${name} ${clang_support_lib})
     target_link_libraries(${name} clangTooling)
     target_link_libraries(${name} clangToolingCore)
     target_link_libraries(${name} ${clang_tooling_refactoring_lib})
@@ -158,9 +155,6 @@
   if(WIN32)
     target_link_libraries(${name} version.lib)
   endif()
-  if (CLAZY_USES_BOOST_REGEX)
-    target_link_libraries(${name} ${Boost_LIBRARIES})
-  endif()
 endmacro()
 
 macro(add_clang_plugin name)
@@ -239,7 +233,7 @@
   install(FILES ${README_manuallevel_FILES} DESTINATION ${CMAKE_INSTALL_DOCDIR}/manuallevel)
 
   # Install more doc files
-  install(FILES README.md COPYING-LGPL2.txt checks.json DESTINATION ${CMAKE_INSTALL_DOCDIR})
+  install(FILES README.md LICENSES/LGPL-2.0-or-later.txt checks.json DESTINATION ${CMAKE_INSTALL_DOCDIR})
 
   # Build docs
   if (CLAZY_MAN_PAGE)
@@ -302,6 +296,7 @@
     clangFrontendTool
     clangRewrite
     clangSerialization
+    ${clang_support_lib}
     clangTooling
     clangStaticAnalyzerCheckers
     clangStaticAnalyzerCore
@@ -323,3 +318,11 @@
         set(str ${input_string})
         set(chunk_size 1000)
         set(result "\n")
+        string(LENGTH ${str} str_size)
+        while (${str_size} GREATER ${chunk_size})
+            string(SUBSTRING ${str} 0 ${chunk_size} chunk)
+            string(SUBSTRING ${str} ${chunk_size} -1 str)
+            set(chunk "R\"meta(${chunk})meta\"\n")
+            string(APPEND result ${chunk})
+            string(LENGTH ${str} str_size)
+        endwhile()

=== debian/changelog ===
clazy (1.12+git20241123-0ubuntu1) plucky; urgency=medium

  * New upstream Git snapshot.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 08 Dec 2024 21:20:15 -0600

clazy (1.12-2) unstable; urgency=medium

  * Consolidate in debian/rules the configuration of the tests to exclude,
    ensuring it can be used also in the 'run-tests' autopkgtest:
    - create a new TESTS_EXCLUDED variable, adding only the test names to it,
    - when running the tests during the build: pass --exclude to run_tests with
      a comma-separated version of $TESTS_EXCLUDED, only in case there are
      tests to exclude
    - add $TESTS_EXCLUDED to the shell configuration shipped by clazy-tests
    - switch the script of the 'run-tests' autopkgtest to use bash, so it is
      possible to use e.g. arrays
    - when running the 'run-tests' autopkgtest: pass --exclude to run_tests
      with a comma-separated version of $TESTS_EXCLUDED, only in case there are
      tests to exclude
  * Improve the way the linking with atomic is done on architectures that need
    that (i.e. currently armel):
    - generalize the addition of link flags in the tests using an environment
      variable; patch debian-tests-extra-libs.diff
    - create a new TESTS_EXTRA_LIBS variable in debian/rules, setting it to
      "-latomic" where needed
    - when running the tests during the build: export $TESTS_EXTRA_LIBS as
      $DEBIAN_EXTRA_LIBS
    - add $TESTS_EXTRA_LIBS to the shell configuration shipped by clazy-tests
    - when running the 'run-tests' autopkgtest: export $TESTS_EXTRA_LIBS as
      $DEBIAN_EXTRA_LIBS
    - drop patch debian-tests-link-atomic.diff, no more needed now

 -- Pino Toscano <pino@debian.org>  Wed, 10 Jul 2024 21:46:06 +0200
